import 'package:html/parser.dart' show parse;
import 'package:html/dom.dart';
import 'dart:io';
import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart' as http;

class ScrapeIt {
  scrapeIt(String url) {
    getJson(url).then((opts) {
      Map conf = opts['confs']['home']['conf']['items'];
      getHtml(opts['conf']['url']).then((document) {
        conf.forEach((key, value) {
          if (key == 'listItem') {
            document.querySelectorAll(value).forEach((Element e) {
              handleData(e, conf['data']);
            });
          } else {
            //handleData(document.querySelector('html'), conf['data']);
          }
        });
      });
    });
  }

  handleData(Element e, Map conf) {
    conf.forEach((key, value) {
      if (key == 'listItem') {
        e.querySelectorAll(value).forEach((Element e) {
          handleData(e, conf['data']);
        });
      } else {
        if(value['selector'] != '' && key != 'resolve'){
          e = e.querySelector(value['selector']);
        }
        if (value['attr'] == null) {
          print("Item" + key + " : " + e.text.trim());
        } else if(key != 'resolve'){
          print("Item" + key + " : " + e.attributes[value['attr']].trim());
        } 
      }
    });
  }

  /// fetch and parse the HTML from [url]
  Future<Document> getHtml(String url) => new HttpClient()
      .getUrl(Uri.parse(url))
      .then((req) {
        req.headers.add(HttpHeaders.COOKIE, "beget=begetok");
        return req;
      })
      .then((req) => req.close())
      .then((res) =>
          res.asyncExpand((bytes) => new Stream.fromIterable(bytes)).toList())
      .then((bytes) => parse(bytes, sourceUrl: url));

  Future<Map> getJson(String url) =>
      http.get(Uri.parse(url)).then((res) => JSON.decode(res.body));
}
